--
-- Piggyback.lua
--
-- Description:
-- Because of a "certain someone"'s coding incompetence, and constant prodding...
-- I made this script just for the fun of it.
--
-- By Flame
--
-- 4-23-21

-- piggybacked -- Person being carried
-- piggybacker -- Person doing the carrying

addHook("MobjMoveCollide", function(tmthing, thing)
	if tmthing and tmthing.valid
	and thing and thing.valid 
	and (thing.type == MT_PLAYER) then -- thing type check
		if (tmthing.z > (thing.z + thing.height)) -- No Z collision? Let's fix that!
		or ((tmthing.z + tmthing.height) < thing.z) then
			return false -- Out of range
		end
		
		-- If you're already being carried, nothing further needs to happen.
		if (tmthing.onpiggy) or (thing.flags & MF_SCENERY) then return false end
		
		-- Let's make sure you're actually getting on the piggybacker's back.
		local tmmangle = R_PointToAngle2(tmthing.x, tmthing.y, thing.x, thing.y) -- tmthing momentum angle
		--local tpbangle = R_PointToAngle2(thing.x, thing.y, tmthing.x, tmthing.y) -- thing piggyback angle
		if (tmmangle < thing.angle + ANGLE_45)
		and (tmmangle > thing.angle - ANGLE_45) -- Left and Right cone
		--and (tpbangle < thing.angle + ANGLE_180+ANGLE_45)
		--and (tpbangle > thing.angle + ANGLE_180-ANGLE_45) -- Left and right cone, but turned around
		and (P_MobjFlip(tmthing)*tmthing.momz < 0) then
			thing.piggybacked = tmthing
			tmthing.piggybacker = thing
			tmthing.onpiggy = true
			tmthing.savedflags = tmthing.flags
			tmthing.flags = $ | (MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SCENERY)
			return true
		end
	end
end, MT_PLAYER) -- our tmthing

addHook("PlayerThink", function(p)
	if p and p.valid
	and p.mo and p.mo.valid then
		p.mo.onpiggy = $ or 0
		p.mo.piggybacked = $ or 0
		p.mo.piggybacker = $ or 0
		
		-- Dismount with BT_SPIN, or if your piggybacker died.
		if ((p.cmd.buttons & BT_SPIN) and p.mo.onpiggy)
		or ((p.mo.piggybacker and p.mo.piggybacker.valid)
		and (p.mo.piggybacker.player and p.mo.piggybacker.player.valid)
		and (p.mo.piggybacker.player.playerstate == PST_DEAD)) then
			p.mo.state = S_PLAY_ROLL
			p.pflags = $ | PF_SPINNING
			p.mo.piggybacker.piggybacked = nil
			p.mo.piggybacker = nil
			p.mo.onpiggy = false			
			P_SetObjectMomZ(p.mo, 6*FRACUNIT, false)
		end
		
		-- If you're piggybacking off someone
		if p.mo.onpiggy
		and p.mo.piggybacker and p.mo.piggybacker.valid
		and p.mo.piggybacker.player and p.mo.piggybacker.player.valid then
			local pbrm = p.mo.piggybacker -- Piggybacker mobj
			P_TeleportMove(p.mo, pbrm.x + pbrm.momx - FixedMul(cos(pbrm.angle), 2*pbrm.radius/3),
								pbrm.y + pbrm.momy - FixedMul(sin(pbrm.angle), 2*pbrm.radius/3),
								pbrm.z + P_GetPlayerSpinHeight(pbrm.player)) -- Teleport to 'em
			-- Proper aim an animation
			p.mo.angle = pbrm.angle
			if (p.mo.state ~= S_PLAY_FALL) then
				p.mo.state = S_PLAY_FALL
				p.panim = PA_FALL
				p.pflags = $ | PF_THOKKED
				p.pflags = $ & ~PF_SPINNING
			end
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 0
		elseif p.mo.savedflags then
			if p.mo.piggybacker and p.mo.piggybacker.valid
				p.mo.piggybacker.piggybacked = nil
				p.mo.piggybacker = nil
			end
			p.mo.onpiggy = false	
			p.mo.flags = p.mo.savedflags
			p.mo.savedflags = 0
		end
	end
end)